package fr.inria.phoenix.diasuite.framework.context.averageefficiency;

import java.io.Serializable;

/**
 * An object to store a value published by the context <code>AverageEfficiency</code>.
 * <p>
 * Compute the average efficiency for each user
 *
 * <pre>
 * context AverageEfficiency as EfficiencySample[] {
 * 	when provided Efficiency no publish;
 * 	when required;
 * }
 * </pre>
 */
public final class AverageEfficiencyValue implements Serializable {
    private static final long serialVersionUID = 0;
    
    private java.util.List<fr.inria.phoenix.diasuite.framework.datatype.efficiencysample.EfficiencySample> value;
    
    /**
     * Get the value of the context <code>AverageEfficiency</code>
     * 
     * <p>
     * Compute the average efficiency for each user
     * 
     * @return the value of the context <code>AverageEfficiency</code>
     */
    public java.util.List<fr.inria.phoenix.diasuite.framework.datatype.efficiencysample.EfficiencySample> value() {
        return value;
    }
    
    public AverageEfficiencyValue(java.util.List<fr.inria.phoenix.diasuite.framework.datatype.efficiencysample.EfficiencySample> value) {
        this.value = value;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((value == null) ? 0 : value.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        AverageEfficiencyValue other = (AverageEfficiencyValue) obj;
        if (value == null) {
            if (other.value != null)
                return false;
        } else if (!value.equals(other.value))
            return false;
        return true;
    }
}
