package fr.inria.phoenix.diasuite.framework.context.format;

import java.io.Serializable;

/**
 * An object to store a value published by the context <code>Format</code>.
 * <p>
 * * HeatingMonitor contexts
 * Format various events for logging purpose
 *
 * <pre>
 * context Format as Event {
 * 	when provided currentHeatingConsumption from HeatingMeter
 * 		always publish;
 * }
 * </pre>
 */
public final class FormatValue implements Serializable {
    private static final long serialVersionUID = 0;
    
    private fr.inria.phoenix.diasuite.framework.datatype.event.Event value;
    
    /**
     * Get the value of the context <code>Format</code>
     * 
     * <p>
     * * HeatingMonitor contexts
     * Format various events for logging purpose
     * 
     * @return the value of the context <code>Format</code>
     */
    public fr.inria.phoenix.diasuite.framework.datatype.event.Event value() {
        return value;
    }
    
    public FormatValue(fr.inria.phoenix.diasuite.framework.datatype.event.Event value) {
        this.value = value;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((value == null) ? 0 : value.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        FormatValue other = (FormatValue) obj;
        if (value == null) {
            if (other.value != null)
                return false;
        } else if (!value.equals(other.value))
            return false;
        return true;
    }
}
