package fr.inria.phoenix.diasuite.framework.context.referenceefficiency;

import java.io.Serializable;

/**
 * An object to store a value published by the context <code>ReferenceEfficiency</code>.
 * <p>
 * Compute the reference efficiency as the average of all users
 *
 * <pre>
 * context ReferenceEfficiency as Float {
 * 	when provided Efficiency no publish;
 * 	when required;
 * }
 * </pre>
 */
public final class ReferenceEfficiencyValue implements Serializable {
    private static final long serialVersionUID = 0;
    
    private java.lang.Float value;
    
    /**
     * Get the value of the context <code>ReferenceEfficiency</code>
     * 
     * <p>
     * Compute the reference efficiency as the average of all users
     * 
     * @return the value of the context <code>ReferenceEfficiency</code>
     */
    public java.lang.Float value() {
        return value;
    }
    
    public ReferenceEfficiencyValue(java.lang.Float value) {
        this.value = value;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((value == null) ? 0 : value.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ReferenceEfficiencyValue other = (ReferenceEfficiencyValue) obj;
        if (value == null) {
            if (other.value != null)
                return false;
        } else if (!value.equals(other.value))
            return false;
        return true;
    }
}
