package fr.inria.phoenix.diasuite.framework.context.window;

import java.io.Serializable;

/**
 * Container for the indices of the context <code>Window</code>.
 * <p>
 * Cut/restart heating when window is open/closed
 * 
 * <pre>
 * context Window as Boolean indexed by user as String {
 * 	when provided state from ContactSensor
 * 	get status from Thermostat maybe publish;
 * }
 * </pre>
 */
public final class WindowIndices implements Serializable {
    private static final long serialVersionUID = 0;
    
    public WindowIndices(java.lang.String user) {
        this._user = user;
    }
    
    // Code for index user
    private java.lang.String _user;
    
    /**
     * Get the <code>user</code> index
     * 
     * @return the value of the <code>user</code> index
     */
    public java.lang.String user() {
        return _user;
    }
    
    /**
     * Set the <code>user</code> index
     * 
     * @param newUser the new value for the <code>user</code> index
     */
    public void setUser(java.lang.String newUser) {
        this._user = newUser;
    }
    // End of code for index user
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((_user == null) ? 0 : _user.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        WindowIndices other = (WindowIndices) obj;
        if (_user == null) {
            if (other._user != null)
                return false;
        } else if (!_user.equals(other._user))
            return false;
        return true;
    }
}
