package fr.inria.phoenix.diasuite.framework.datatype.efficiencysample;

import java.io.Serializable;

/**
 * Used to store the instant or average efficiency for each user
 * 
 * <pre>
 * structure EfficiencySample {
 * 	efficiency as Float;
 * 	user as String;
 * }
 * </pre>
 */
public class EfficiencySample implements Serializable {
    private static final long serialVersionUID = 0;

    // Code for field efficiency
    private java.lang.Float efficiency;
    
    /**
     * Returns the value of the efficiency field.
     * 
     * <pre>
     * efficiency as Float
     * </pre>
     * @return the value of efficiency
     */
    public java.lang.Float getEfficiency() {
        return efficiency;
    }
    
    /**
     * Set the value of the efficiency field.
     * 
     * <pre>
     * efficiency as Float
     * </pre>
     * @param efficiency the new value of efficiency
     */
    public void setEfficiency(java.lang.Float efficiency) {
        this.efficiency = efficiency;
    }
    // End of code for field efficiency

    // Code for field user
    private java.lang.String user;
    
    /**
     * Returns the value of the user field.
     * 
     * <pre>
     * user as String
     * </pre>
     * @return the value of user
     */
    public java.lang.String getUser() {
        return user;
    }
    
    /**
     * Set the value of the user field.
     * 
     * <pre>
     * user as String
     * </pre>
     * @param user the new value of user
     */
    public void setUser(java.lang.String user) {
        this.user = user;
    }
    // End of code for field user

    public EfficiencySample() {
    }

    public EfficiencySample(java.lang.Float efficiency,
            java.lang.String user) {
        this.efficiency = efficiency;
        this.user = user;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((efficiency == null) ? 0 : efficiency.hashCode());
        result = prime * result + ((user == null) ? 0 : user.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        EfficiencySample other = (EfficiencySample) obj;
        if (efficiency == null) {
            if (other.efficiency != null)
                return false;
        } else if (!efficiency.equals(other.efficiency))
            return false;
        if (user == null) {
            if (other.user != null)
                return false;
        } else if (!user.equals(other.user))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "EfficiencySample [" + 
            "efficiency=" + efficiency +", " + 
            "user=" + user +
        "]";
    }
}
