package fr.inria.phoenix.scenario.heatingmonitor.impl;

import fr.inria.phoenix.diasuite.framework.context.analysis.AbstractAnalysis;
import fr.inria.phoenix.diasuite.framework.context.averageefficiency.AbstractAverageEfficiency;
import fr.inria.phoenix.diasuite.framework.context.efficiency.AbstractEfficiency;
import fr.inria.phoenix.diasuite.framework.context.format.AbstractFormat;
import fr.inria.phoenix.diasuite.framework.context.referenceefficiency.AbstractReferenceEfficiency;
import fr.inria.phoenix.diasuite.framework.context.window.AbstractWindow;
import fr.inria.phoenix.diasuite.framework.controller.cutrestart.AbstractCutRestart;
import fr.inria.phoenix.diasuite.framework.controller.log.AbstractLog;
import fr.inria.phoenix.diasuite.framework.controller.mail.AbstractMail;
import fr.inria.phoenix.diasuite.framework.misc.AppComponentBinder;
import fr.inria.phoenix.scenario.heatingmonitor.impl.context.*;
import fr.inria.phoenix.scenario.heatingmonitor.impl.controller.*;

/* (non-Javadoc)
 * The binder to provides the various components of the application
 * @see fr.inria.phoenix.diasuite.framework.misc.AppComponentBinder
 */
public class ComponentBinder extends AppComponentBinder {

	@Override
	public Class<? extends AbstractAnalysis> getAnalysisClass() {
		return Analysis.class;
	}

	@Override
	public Class<? extends AbstractAverageEfficiency> getAverageEfficiencyClass() {
		return AverageEfficiency.class;
	}

	@Override
	public Class<? extends AbstractEfficiency> getEfficiencyClass() {
		return Efficiency.class;
	}

	@Override
	public Class<? extends AbstractFormat> getFormatClass() {
		return Format.class;
	}

	@Override
	public Class<? extends AbstractReferenceEfficiency> getReferenceEfficiencyClass() {
		return ReferenceEfficiency.class;
	}
	
	@Override
	public Class<? extends AbstractLog> getLogClass() {
		return Log.class;
	}
	
	@Override
	public Class<? extends AbstractMail> getMailClass() {
		return Mail.class;
	}

	@Override
	public Class<? extends AbstractWindow> getWindowClass() {
		return Window.class;
	}

	@Override
	public Class<? extends AbstractCutRestart> getCutRestartClass() {
		return CutRestart.class;
	}
	
}
