package fr.inria.phoenix.scenario.heatingmonitor.impl.context;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.datatype.event.Event;
import fr.inria.phoenix.diasuite.framework.datatype.state.State;
import fr.inria.phoenix.diasuite.framework.context.format.AbstractFormat;
import fr.inria.phoenix.diasuite.framework.device.heatingmeter.CurrentHeatingConsumptionFromHeatingMeter;

/* Format various events for logging purpose.
 * The implementation of the Format context
 * @see fr.inria.phoenix.diasuite.framework.context.format.AbstractFormat
 */
public class Format extends AbstractFormat {
    
    public Format(ServiceConfiguration serviceConfiguration) {
        super(serviceConfiguration);
    }
    
    static private String formatEvent(String event, String user, String location) {
    	return event + "@" + user + "/" + location;
    }
    
    /* (non-Javadoc)
     * @see fr.inria.phoenix.diasuite.framework.context.format.AbstractFormat#onCurrentHeatingConsumptionFromHeatingMeter(CurrentHeatingConsumptionFromHeatingMeter)
     */
    @Override
    protected Event onCurrentHeatingConsumptionFromHeatingMeter(
    		CurrentHeatingConsumptionFromHeatingMeter currentHeatingConsumptionFromHeatingMeter) {
    	String user = currentHeatingConsumptionFromHeatingMeter.sender().user();
    	String location = currentHeatingConsumptionFromHeatingMeter.sender().location();
    	State state = currentHeatingConsumptionFromHeatingMeter.value();
    	String content = formatEvent(state.getState(), user, location);
    	return new Event(content, state.getTimestamp());    	
    }
}
