package fr.inria.phoenix.scenario.heatingmonitor.impl.context;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.referenceefficiency.AbstractReferenceEfficiency;
import fr.inria.phoenix.diasuite.framework.context.efficiency.EfficiencyValue;

/* Compute the reference efficiency as the average of all users.
 * The implementation of the ReferenceEfficiency context
 * @see fr.inria.phoenix.diasuite.framework.context.referenceefficiency.AbstractReferenceEfficiency
 */
public class ReferenceEfficiency extends AbstractReferenceEfficiency {
	private int n = 0; // number of samples seen
	private Float reference;
    
    public ReferenceEfficiency(ServiceConfiguration serviceConfiguration) {
        super(serviceConfiguration);
    }
    
    /* Update the average efficiency over all users.
     * @see fr.inria.phoenix.diasuite.framework.context.referenceefficiency.AbstractReferenceEfficiency#onEfficiency(EfficiencyValue)
     */
    @Override
    protected void onEfficiency(EfficiencyValue efficiencyValue) {
    	Float e = efficiencyValue.value().getEfficiency();
    	if(n == 0)
    		reference = e;
    	else {
    		reference = (n * reference + e) /(n + 1);
    	}
    	System.out.println("ref["+n+"]="+reference);
    	n++; // increment number of samples seen
    }

	@Override
	protected Float getValue() {
		return reference;
	}
}
