package fr.inria.phoenix.scenario.heatingmonitor.impl.context;

import java.util.ArrayList;
import java.util.HashMap;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.window.AbstractWindow;
import fr.inria.phoenix.diasuite.framework.device.contactsensor.StateFromContactSensor;

public class Window extends AbstractWindow {
	private HashMap<String,ArrayList<String>> 
		paused = new HashMap<String,ArrayList<String>>();

	public Window(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
	}

	@Override
	protected WindowValuePublishable onStateFromContactSensor(
			StateFromContactSensor stateFromContactSensor,
			DiscoverForStateFromContactSensor discover) {
		String user = stateFromContactSensor.sender().user();
		String location = stateFromContactSensor.sender().location();
		ThermostatCompositeForStateFromContactSensor
			thermostats = discover.thermostats().whereUser(user);
		if(thermostats.isEmpty())
			return new WindowValuePublishable(null, user, false); // do nothing
		String state = stateFromContactSensor.value().getState();
		if(state.equals("open") && thermostats.anyOne().getStatus()) {
			if(!paused.containsKey(user)) {
				paused.put(user, new ArrayList<String>());
				paused.get(user).add(location);
				return new WindowValuePublishable(false, user, true); // turn heating off
			} else {
				paused.get(user).add(location);
				return new WindowValuePublishable(null, user, false); // do nothing				
			}
		} else if(state.equals("close") && paused.containsKey(user)) {
			paused.get(user).remove(location);
			if(paused.get(user).isEmpty()) {
				paused.remove(user);
				return new WindowValuePublishable(true, user, true); // turn heating on
			} else {
				return new WindowValuePublishable(null, user, false); // do nothing				
			}
		} else return new WindowValuePublishable(null, user, false); // do nothing
	}

}