package fr.inria.phoenix.scenario.heatingmonitor.impl.controller;

import java.util.ArrayList;
import java.util.List;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.controller.mail.AbstractMail;
import fr.inria.phoenix.diasuite.framework.context.analysis.AnalysisValue;
import fr.inria.phoenix.diasuite.framework.datatype.contact.Contact;
import fr.inria.phoenix.diasuite.framework.datatype.file.File;

/* Send message about users needing an audit.
 * The implementation of the Mail context
 * @see fr.inria.phoenix.diasuite.framework.controller.mail.AbstractMail
 */
public class Mail extends AbstractMail {
	List<String> groups = new ArrayList<String>();
	private Contact admin = new Contact("The Boss", "demo1.diasuitebox@gmail.com",
		"nophone", "nomobile", "nourl", groups);
    
    public Mail(ServiceConfiguration serviceConfiguration) {
        super(serviceConfiguration);
    }

    /* (non-Javadoc)
     * @see fr.inria.phoenix.diasuite.framework.controller.mail.AbstractMail#onAnalysis(AnalysisValue, DiscoverForAnalysis)
     */
    @Override
    protected void onAnalysis(AnalysisValue analysis, DiscoverForAnalysis discover) {
    	String user = analysis.value();
    	discover.mailers().anyOne().sendMessage(admin,
    			"Inefficient heating for user", //title
    			"Chronical inefficient heating detected at user " + user + ".",
    			new ArrayList<File>()); //attachments
    }
}
